<template>
    <div class="app-container">
        <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch"  @submit.native.prevent label-width="68px">
            <el-form-item label="体检号" prop="tjNum">
                <el-input ref="inputName" v-model="queryParams.tjNum" placeholder="请输入体检号" style="width: 170px" clearable
                    @keyup.enter.native="handleQuery" @blur="handleQuery" />
            </el-form-item>
            <el-form-item>
                <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
                <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
            </el-form-item>
        </el-form>

        <template>
            <h4 v-if="tjCustomerName">姓名：{{tjCustomerName }}</h4>
            <el-table border v-loading="loading" :data="orderList" >
                <el-table-column label="序号" align="center" prop="newID"  />
               

                <el-table-column label="体检号" align="center" prop="tjNumber" />
                <el-table-column label="已完成项目" align="center" prop="tjNumber" /> <el-table-column label="未完成项目"
                    align="center" prop="tjNumber" /> 
                    <el-table-column label="弃检项目" align="center" prop="tjNumber" />
                <el-table-column label="延期项目" align="center" prop="tjNumber" />

            </el-table>
        </template>

        <div class="pag">
            <div class="pag1">
                <el-pagination background @size-change="handleSizeChange" @current-change="handleCurrentChange"
                    :current-page="queryParams.pageNum" :page-sizes="[10, 20, 30, 40]" :page-size="queryParams.pageSize"
                    layout="total, sizes, prev, pager, next, jumper" :total="total">
                </el-pagination>
                <!-- <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNum" :limit.sync="queryParams.pageSize"
            @pagination="getList" /> -->
            </div>
        </div>
    </div>
</template>
  
<script>
import {
    listOrder,
    getNumber,
    hasReportEnd,
    hasReport,
    gettoPdf,
    getPdf,
    getOrderList,
} from "@/api/hosp/order";
import { getwater } from "@/api/hosp/customer";
import ViewPdf from "@/components/ViewPdf";
import { projectGetList, getaddtTransition } from "@/api/system/tijian";
export default {
    components: {
        ViewPdf,
    },
    dicts: ["dict_pay_type"],
    name: "Order",
    data() {
        return {
            tjCustomerName: "",
            orderIds: "",
            tjnumbers: "",
            cusIds: "",
            userIds: "",
            cusIdcard: "",
            cusName: "",
            cusPhone: "",
            cusSex: "",
            reportTimeList: "",
            createTimeList: "",
            cusId: "",
            payType: "0",
            dialogVisible: false,
            daoZhenDan: false,
            Projectopen: false,
            Projectopen1: false,
            src: "",
            url: "",
            flag: true,
            bill: null,
            Treedata: [],
            defaultProps: {
                children: "tjProjectList",
                label: "proName",
            },
            discount: 10,
            DataList: [],
            // 套餐提交按钮
            confirm: false,
            list1: true,
            activeName: "1",
            proIds: [],
            TotalPrice1: 0,
            numberList: [],
            dialogVisible: false,
            // 遮罩层
            loading: false,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            userId: "",
            // 总条数
            total: 0,
            // 体检记录表格数据
            orderList: [],
            // 弹出层标题
            title: "",
            orderId: "",
            // 是否显示弹出层
            open: false,
            // 日期范围
            datetimerange: [],
            // 查询参数
            queryParams: {
                pageNum: 1,
                pageSize: 10,
                djbeginTime: null,
                djendTime: null,
                tjNum: null,
                bgbeginTime: null,
                bgendTime: null,
            },
            startTime: "",
            startTime1: "",
            // 表单参数
            form: {
                tjType: 2,
            },
            // 表单校验
            rules: {},
            pickerOptions: {
                shortcuts: [
                    {
                        text: "最近一周",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date(new Date().setHours(0, 0, 0, 0));
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                    {
                        text: "最近一个月",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date(new Date().setHours(0, 0, 0, 0));
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                    {
                        text: "最近三个月",
                        onClick(picker) {
                            const end = new Date();
                            const start = new Date(new Date().setHours(0, 0, 0, 0));
                            start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
                            picker.$emit("pick", [start, end]);
                        },
                    },
                ],
            },
        };
    },
    created() {
    //    this.getList()
    },
    mounted() {
        this.$nextTick(() => {
            this.$refs.inputName.focus();
        });
    },
    methods: {
        // / 处理默认选中当前日期
        getNowTime() {
            var curDate = new Date(new Date().setHours(0, 0, 0, 0)).getTime();
            var dayNum = 7 * 24 * 3600 * 1000;
            var threeDays = curDate - dayNum;
            var sDay = this.getLocalTime(threeDays);
            var end = this.getLocalTime(curDate);
            this.createTimeList = [sDay, end];
        },
        add0(m) {
            return m < 10 ? "0" + m : m;
        },
        getLocalTime(nS) {
            var time = new Date(nS);
            var y = time.getFullYear();
            var m = time.getMonth() + 1;
            var d = time.getDate();
            var h = time.getHours();
            var mm = time.getMinutes();
            return (
                y +
                "-" +
                this.add0(m) +
                "-" +
                this.add0(d) +
                " " +
                this.add0(h) +
                ":" +
                this.add0(mm)
            );
        },
        dateChangebirthday1(val) {
            this.startTime = val;
        },
        dateChangebirthday2(val) {
            this.startTime1 = val;
        },
        /** 查询体检记录列表 */
        getList() {
            this.queryParams.djbeginTime = this.startTime[0];
            this.queryParams.djendTime = this.startTime[1];
            this.loading = true;
            getOrderList(this.queryParams).then((response) => {
                this.orderList = response.data.list;
                if (this.orderList) {
                    this.orderList.forEach((item, index) => {
                        if(this.queryParams.tjNum){
                            this.tjCustomerName = item.tjCustomerName
                        }else{
                            this.tjCustomerName = ""
                        }
                        
                        item.newID =
                            (this.queryParams.pageNum - 1) * this.queryParams.pageSize +
                            index +
                            1;
                    });
                }
                this.total = response.data.total;
                this.loading = false;
            });
        },
        /** 点击显示导检单报表*/ //lige    开始
        handleReport(row) {
            const tjNumber = row.tjNumber;
            const viewNum = "792931586196398080";
            const params = { viewNum, tjNumber };
            hasReport(tjNumber).then((res) => {
                if (res == 1) {
                    this.$tab.openPage("导诊单", "/report/breDailyReport", params);
                } else {
                    this.$message.error("该用户暂无项目！");
                }
            });
        },
        /** 点击显示导检单报表*/ //lige    开始
        handleReport1(row) {
            const tjNumber = this.tjnumbers;
            const viewNum = "792931586196398080";
            const params = { viewNum, tjNumber };
            hasReport(tjNumber).then((res) => {
                if (res == 1) {
                    this.$tab.openPage("导诊单", "/report/breDailyReport", params);
                } else {
                    this.$message.error("该用户暂无项目！");
                }
            });
        },
  
        //lige   结束
        viewReport(row) {
            const tjNumber = row.tjNumber;
            const flag = true;
            getPdf(tjNumber, flag).then((response) => {
                if (response.size === 0) {
                    this.$message.error("该用户体检报告暂未完成！");
                    this.dialogVisible = false;
                } else {
                    this.dialogVisible = true;
                    this.url = window.webkitURL.createObjectURL(response); //将后端返回的blob文件读取出url
                }
            });
        },

 

        handleSizeChange(val) {
            this.queryParams.pageNum = 1;
            this.queryParams.pageSize = val;
            this.getList();
        },
        handleCurrentChange(val) {
            this.queryParams.pageNum = val;
            this.getList();
        },

        // 取消按钮
        cancel() {
            this.open = false;
            this.reset();
        },
        // 表单重置
        reset() {
            this.form = {
                orderId: null,
                userId: null,
                tjType: null,
                tjNumber: null,
                tjSerialNumber: null,
                pacId: null,
                createTime: null,
                finishTime: null,
                updateTime: null,
                reportTime: null,
                createBy: null,
                updateBy: null,
                deleted: null,
                firmId: null,
                firmDeptName: null,
                firmWorkId: null,
                photo: null,
                djbeginTime: null,
                djendTime: null,
                bgbeginTime: null,
                bgendTime: null,
            };
            this.resetForm("form");
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.queryParams.pageNum = 1;
            this.getList();
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm("queryForm");
            this.orderList =[];
            this.tjCustomerName= ""
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            selection.forEach((item) => {
                this.orderIds = item.orderId;
                this.tjnumbers = item.tjNumber;
                this.cusIds = item.tjCusIdCard;
                this.userIds = item.userId;
                this.cusIdcard = item.tjCusIdCard;
                this.cusName = item.tjCustomerName;
                this.cusPhone = item.tjCustomerPhone;
                this.cusSex = item.tjCustomerSex;
            });
            this.ids = selection.map((item) => item.orderId);
            // this.tjNumbers = selection.map((item) => item.tjNumber);
            this.single = selection.length !== 1;
            this.multiple = !selection.length;
        },
        /** 新增按钮操作 */
        // handleAdd() {
        //   this.reset();
        //   this.open = true;
        //   this.title = "添加体检记录";
        // },

        /** 订单流水按钮 */
        handleUpdate(row) {
            const tjNumber = row.tjNumber;
            this.open = true;
            getNumber(tjNumber).then((response) => {
                // this.form = response.data;
                this.numberList = response.data.charging;
                this.bill = response.data.water;
                this.title = "订单流水";
            });
        },
        /** 订单明细按钮 */
        handleUpdate1(row) {
            const tjNumber = this.tjnumbers;
            this.open = true;
            getNumber(tjNumber).then((response) => {
                // this.form = response.data;
                this.numberList = response.data.charging;
                this.bill = response.data.water;
                this.title = "订单流水";
            });
        },

        // 补录项目
        handleProject(row) {
            this.orderId = row.orderId;
            this.cusId = row.tjCusIdCard;
            this.userId = row.userId;
            this.customer = {
                cusIdcard: row.tjCusIdCard,
                cusName: row.tjCustomerName,
                cusPhone: row.tjCustomerPhone,
                cusSex: row.tjCustomerSex,
            };
            if (row.tjType) {
                this.form.tjType = parseInt(row.tjType);
            } else {
                this.form.tjType = 0;
            }
            /** 查询部门下拉树结构 */
            projectGetList().then((response) => {
                this.Treedata = response.data.list;
            });
            this.Projectopen = true;
            this.title = "补录项目";
        },
        // 补录项目
        handleProject1(row) {
            this.orderId = this.ids;
            this.cusId = this.cusIds;
            this.userId = this.userIds;
            this.customer = {
                cusIdcard: this.cusIdcard,
                cusName: this.cusName,
                cusPhone: this.cusPhone,
                cusSex: this.cusSex,
            };
            if (row.tjType) {
                this.form.tjType = parseInt(row.tjType);
            } else {
                this.form.tjType = 0;
            }
            /** 查询部门下拉树结构 */
            projectGetList().then((response) => {
                this.Treedata = response.data.list;
            });
            this.Projectopen1 = true;
            this.title = "补录项目";
        },
        // 点击获取每个树节点
        handleCurrentChecked(data, checked, checkedNodes) {
            if (!data.tjProjectList) {
                return;
            }
            if (checked === true) {
                this.DataList.push(data);
            } else {
                this.DataList.pop(data);
                this.list1 = true;
            }
            // let DataList = selectedobj.checkedNodes
            // if (DataList.length>0) {
            //   DataList.forEach(item => {
            //     if (nodeobj.proId === item.proId) {
            //       this.DataList = []
            //       this.DataList.push(item)

            //       this.list1 = false;
            //     }
            //   })
            // }else{
            //   this.DataList = []
            //   this.list1 = true;
            // }
            this.TotalPrice1 = 0;
            this.proIds = [];
            if (this.DataList.length != 0) {
                this.list1 = false;
                this.DataList.forEach((item) => {
                    this.TotalPrice1 = item.proPrice + this.TotalPrice1;
                    this.proIds.push(item.proId);
                });
            }
        },

        // 收费按钮
        submitPrice() {
            let data = {
                cusId: this.cusId,
                proIds: this.proIds,
            };
            getaddtTransition(data).then((response) => {
                if (response.code === 200) {
                    let tjType = this.form.tjType;
                    let copeWith = this.TotalPrice1;
                    let paidIn = copeWith * (this.discount / 10);
                    let discount = this.discount;
                    let data = {
                        customer: this.customer,
                        paidIn,
                        discount,
                        copeWith,
                        tjType,
                        orderId: this.orderId,
                        tjProIds: this.proIds,
                        payType: this.payType,
                    };
                    getwater(data).then((res) => {
                        this.$modal.msgSuccess("提交成功");
                        this.mobanId = res.data.mobanId;
                        this.waterId = res.data.waterId;
                        const tjnumber = this.waterId;
                        const viewNum = this.mobanId;
                        const params = { viewNum, tjnumber };
                        this.$tab.openPage("收款小票", "/report/charge", params);
                        this.Projectopen = false;
                    });
                }
            });
        },
        // 收费按钮
        submitPrice1() {
            let data = {
                cusId: this.cusIds,
                proIds: this.proIds,
            };
            getaddtTransition(data).then((response) => {
                if (response.code === 200) {
                    let tjType = this.form.tjType;
                    let copeWith = this.TotalPrice1;
                    let paidIn = copeWith * (this.discount / 10);
                    let discount = this.discount;
                    let data = {
                        customer: this.customer,
                        paidIn,
                        discount,
                        copeWith,
                        tjType,
                        orderId: this.orderIds,
                        tjProIds: this.proIds,
                        payType: this.payType,
                    };
                    getwater(data).then((res) => {
                        this.$modal.msgSuccess("提交成功");
                        this.mobanId = res.data.mobanId;
                        this.waterId = res.data.waterId;
                        const tjnumber = this.waterId;
                        const viewNum = this.mobanId;
                        const params = { viewNum, tjnumber };
                        this.$tab.openPage("收款小票", "/report/charge", params);
                        this.Projectopen1 = false;
                    });
                }
            });
        },


        /** 导出按钮操作 */
        handleExport() {
            this.download(
                "hosp/order/export",
                {
                    ...this.queryParams,
                },
                `order_${new Date().getTime()}.xlsx`
            );
        },
    },
};
</script>
<style lang="scss">
.pag {
    width: 100%;
    display: flex;
    justify-content: center;
    margin-top: 15px;
}

.pag1 {
    width: 30%;
}

.main {
    height: 700px;
    overflow: hidden;
}

#printIframe::-webkit-scrollbar {
    width: 6px;
}

/* 修改 滚动条的 下面 的 样式 */
#printIframe::-webkit-scrollbar-track {
    background-color: white;
    -webkit-border-radius: 2em;
    -moz-border-radius: 2em;
    border-radius: 2em;
}

/* 修改 滑块 */
#printIframe::-webkit-scrollbar-thumb {
    background-color: #dcdfe6;
    -webkit-border-radius: 2em;
    -moz-border-radius: 2em;
    border-radius: 2em;
}

// .el-dialog {
//   width: 1264px;
//   min-height: 800px;
// }

// .el-dialog__header {
//   display: flex;
//   justify-content: space-between;
//   align-items: center;
// }

// .el-dialog__body {
//   padding: 20px;
// }

.outside {
    width: 700px;
    display: flex;
    margin-top: 8px;
}

.outside1 {
    width: 700px;
    display: flex;
    margin-top: 8px;
}
</style>
  